//+------------------------------------------------------------------+
//|                                                       Hotash.mq4 |
//|                                                               Me |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Me"
#property link      ""
#import "stdlib.ex4"

extern double LotSize       =0.1;
extern int    MagicNumber   =198912;
extern int    MagicNumber_3_0=786;
extern int    MagicNumber_3_1=785;
extern int    TakeProfit_1  = 15;
extern int    TakeProfit_2  = 25;
extern int    TakeProfit_3  = 50;
extern int    StopLoss      = 100;   
extern double TrailingStart =10;
extern double TrailingStep  =2;
extern double BreakEvenStart=5;
extern double BreakEven     =1;
extern int    Slippage      =3;
extern double Value_Diff    = 0.0003;
extern int    Fast_MA_Value =25;
extern int    Slow_MA_Value =750;





int iOrderType_Buy  =0;
int iOrderType_Sell =1;
int BuyOrder;
int SellOrder;
int BuyOrder_1,BuyOrder_2, BuyOrder_3 ;
int SellOrder_1, SellOrder_2, SellOrder_3;
double ticket_buy_3,ticket_sell_3;
int Buy_Ticket_3,Sell_Ticket_3;


int iOpenOrders_Sell;
int iOpenOrders_Buy;


int iLastError;


double dPip;
double dStopLossPrice, dTakeProfitPrice;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{

if(Digits == 2 || Digits == 3){
	dPip = 0.01;
}else{
if(Digits == 4 || Digits == 5)
	dPip = 0.0001;
}

return(0);

}

int deinit()
{

Comment("");
return(0);

}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+



int start()
{
double Fast_EMA, Slow_SMA, MA_Difference_1, MA_Difference_2;
bool bOrderClosed;

//count open buy orders.
iOpenOrders_Buy = CntOrd(iOrderType_Buy,MagicNumber,Symbol());

//count open sell orders.
iOpenOrders_Sell = CntOrd(iOrderType_Sell,MagicNumber,Symbol());
History_Calling(Symbol(), MagicNumber);
Trailing_Stop(Symbol(), MagicNumber); 

Fast_EMA = iMA(NULL,0,Fast_MA_Value,0,MODE_EMA,PRICE_CLOSE,0);

Slow_SMA = iMA(NULL,0,Slow_MA_Value,0,MODE_SMA,PRICE_CLOSE,0);

MA_Difference_1= Fast_EMA-Slow_SMA;

MA_Difference_2= Slow_SMA-Fast_EMA;


if (Fast_EMA>Slow_SMA)
{
if (MA_Difference_1>=Value_Diff && iOpenOrders_Buy ==0)
{

	
//Start - Close open sell positions------------------------------------------
//check if there are open sell positions.
	if(iOpenOrders_Sell > 0) {

	bOrderClosed = closeSellOrder(iOrderType_Sell); //Closing Sell order
	
		if(bOrderClosed){
			Print("Sell Order Closed");
		
		}else{ //order was not closed.
			iLastError = GetLastError();
			
		}
	}//end if(iOpenOrders_Sell > 0) {
//End - Close open sell positions------------------------------------------
		
	   double OpenPrice=Ask;
		int count=3;

		double  dTakeProfitPrice_1,dTakeProfitPrice_2,dTakeProfitPrice_3;
		dStopLossPrice = NormalizeDouble(OpenPrice - StopLoss * dPip,Digits);
	
		dTakeProfitPrice_1 = NormalizeDouble(OpenPrice + TakeProfit_1 * dPip,Digits);
		dTakeProfitPrice_2 = NormalizeDouble(OpenPrice + TakeProfit_2 * dPip,Digits);
		dTakeProfitPrice_3 = NormalizeDouble(OpenPrice + TakeProfit_3 * dPip,Digits);
		
iLastError = 0;
   if (count==3) 
    {
    BuyOrder_1=OrderSend(Symbol(), iOrderType_Buy, LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_1, "Buy Order",MagicNumber, 0,Blue);
    if (BuyOrder_1>0) //Checking if the order was opened or not
      { 
      Print("Buy Order 1 Opened");
      count = count - 1; 
      }
     else {
          iLastError = GetLastError();                               
          Print( "Error in Opening Buy Order 1");
} 

}

  if (count==2) 
    {
    BuyOrder_2=OrderSend(Symbol(), iOrderType_Buy, LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_2, "Buy Order",MagicNumber, 0,Blue);
    if (BuyOrder_2>0) 
      { 
      Print ("Buy Order 2 Opened");
      count = count - 1; 
      }
     else {
          iLastError = GetLastError();
          Print( "Error in Opening Buy Order 2");
} 

}

if (count==1) 
    {
    BuyOrder_3=OrderSend(Symbol(), iOrderType_Buy, LotSize,OpenPrice,Slippage,dStopLossPrice,dTakeProfitPrice_3, "BuyOrder_3",MagicNumber, 0,Blue);
 
    if (BuyOrder_3>0) 
      {
     Print ("Buy Order 3 Opened");
      count = count - 1; 
      }
     else {
          iLastError = GetLastError();                               
          Print( "Error in Opening Buy Order 3");
}  

}
}
}
///////////////////////////// Checking Selling Condition

if (Fast_EMA<Slow_SMA)
{
if (MA_Difference_2>=Value_Diff && iOpenOrders_Sell ==0)
{
if(iOpenOrders_Buy > 0) {
		
		bOrderClosed = closeBuyOrder(iOrderType_Buy); //Closing Buy order
	
		if(bOrderClosed){
			Print ("Opened Buy order got closed");
		}else{
			iLastError = GetLastError();
			Print("Error in closing Opened Buy Orders");	
		}//end else if(bOrderClosed){
	}//end if(iOpenOrders_Buy > 0) {
	
	
    OpenPrice=Bid;
  	count=3;	
      
		dStopLossPrice = NormalizeDouble(OpenPrice + StopLoss * dPip,Digits);
		
		dTakeProfitPrice_1 = NormalizeDouble(OpenPrice - TakeProfit_1 * dPip,Digits);
		dTakeProfitPrice_2 = NormalizeDouble(OpenPrice - TakeProfit_2 * dPip,Digits);
		dTakeProfitPrice_3 = NormalizeDouble(OpenPrice - TakeProfit_3 * dPip,Digits);
		
iLastError = 0;
   if (count==3) 
    {
  SellOrder_1=OrderSend(Symbol() , iOrderType_Sell , LotSize,OpenPrice,Slippage ,dStopLossPrice ,dTakeProfitPrice_1 , "Sell Order",MagicNumber, 0,Red);
		
    if (SellOrder_1>0) //Checking if the order was opened or not
      { 
      Print("Sell Order 1 Opened");
      count = count - 1; 
      }
     else {
          iLastError = GetLastError();                               
          Print("Error in opening Sell order 1");

} 

}

  if (count==2) 
   {
  SellOrder_2=OrderSend(Symbol() , iOrderType_Sell , LotSize,OpenPrice,Slippage ,dStopLossPrice ,dTakeProfitPrice_2 , "Sell Order",MagicNumber, 0,Red);
		
    if (SellOrder_2>0) //Checking if the order was opened or not
      { 
       Print("Sell Order 2 Opened");
      count = count - 1; 
      }
     else {
          iLastError = GetLastError();                               
          Print("Error in opening Sell order 2");

} 

}

if (count==1) 
   {
  SellOrder_3=OrderSend(Symbol() , iOrderType_Sell , LotSize,OpenPrice,Slippage ,dStopLossPrice,dTakeProfitPrice_3 , "SellOrder_3",MagicNumber, 0,Red);
	
    if (SellOrder_3>0) //Checking if the order was opened or not
      { 
      Print("Sell Order 3 Opened");
      count = count - 1; 
      }
     else {
          iLastError = GetLastError();                               
          Print("Error in opening Sell order 3");

} 

}
}
}


return(0);
}

//+------------------------------------------------------------------+
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CntOrd(int Type, int Magic, string Symb) {
//return number of orders matching the order type and symbol specific parameters. Magic number param is optional
int _CntOrd;
_CntOrd=0;
int iTotalOrders_;
iTotalOrders_ = OrdersTotal();

for(int i=iTotalOrders_;i>=0;i--)
{
   if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
 // Print("i=",i,"Symbol ", OrderSymbol(), " Order type= ", OrderType(), "Magic =", OrderMagicNumber()," ", Magic);
  
  
   if (OrderSymbol()==Symb) {
      if ( OrderType()==Type && OrderMagicNumber()==Magic) _CntOrd++;
         }
}
return(_CntOrd);
}//end int CntOrd(int Type, int Magic, string Symb) {
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool closeBuyOrder(int iBuytype)
{
bool bClosed_;

if(OrdersTotal()>0)
{
for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
{
OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES);

if(iBuytype==OP_BUY && OrderType()==OP_BUY)
{
if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
 {
RefreshRates();

bClosed_=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits), Slippage);

}
}
}
}

return(bClosed_);
}//end bool closeBuyOrder(int iBuytype)

//===========================================================================================

bool closeSellOrder(int iSelltype)
{
bool bClosed_;

	if(OrdersTotal()>0)
	{
		for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
		{
			if(!OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES)) continue;

			if(iSelltype==OP_SELL && OrderType()==OP_SELL)
			{
				if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
				{
					RefreshRates(); 
					bClosed_ = OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage);
				}//end if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
			}//end if(iSelltype==OP_SELL && OrderType()==OP_SELL)
		}//end for(int Counter=OrdersTotal()-1;Counter>=0;Counter--)
	}//end if(OrdersTotal()>0)
	
	
	return(bClosed_);
}//end bool closeSellOrder(int Selltype)
/////////////////////////////////////////////////////////////
void Trailing_Stop(string symbol, int magic)
           {
           double New_SL,vPoint,vSlippage; 
           if (Digits == 3 || Digits == 5)
            {vPoint = Point * 10; vSlippage = Slippage * 10;    }
            else
             {vPoint = Point; vSlippage = Slippage;}
            RefreshRates();            
            
            int Spread = (Ask - Bid) / vPoint;            
            for ( int i=OrdersTotal()-1; i>=0; i--)    
            {
             if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
              {
                if(OrderSymbol()==symbol)
                 {
                   if(OrderMagicNumber()==magic)
                   {
                     if(OrderType()==OP_BUY)
                      {
                       if(OrderStopLoss()==OrderOpenPrice()-(StopLoss*vPoint))
                        {
                         if(Bid>=OrderOpenPrice()+(BreakEvenStart*vPoint))
                          {
                           if(OrderOpenPrice()+(BreakEvenStart*vPoint)>=OrderOpenPrice()+Spread+(BreakEven*vPoint))
                            {
                              New_SL=OrderOpenPrice()+(BreakEven*vPoint);
                              
                               OrderModify(OrderTicket(),OrderOpenPrice(),New_SL,OrderTakeProfit(),0,Red);
                               
                                Alert("MoveTheSL :Attempting to move SL of ",symbol," to ",New_SL);
                                Print("MoveTheSL :Attempting to move SL of ",symbol," to ",New_SL);
                            }
                           }
                          } //End if(OrderStopLoss()==OrderOpenPrice()-(StopLoss*vPoint));
                          else
                          {
                           if(Bid-(TrailingStart*vPoint)>=OrderStopLoss())
                            {
                              New_SL=OrderStopLoss()+(TrailingStep*vPoint);
                              
                               OrderModify(OrderTicket(),OrderOpenPrice(),New_SL,OrderTakeProfit(),0,Red);
                               
                                Alert("MoveTheSL :Attempting to move SL of ",symbol," to ",New_SL);
                                Print("MoveTheSL :Attempting to move SL of ",symbol," to ",New_SL);
                            }
                           } //End else 
                          }// End if(OrderType==OP_BUY)
                          
                     if(OrderType()==OP_SELL)
                      {
                       if(OrderStopLoss()==OrderOpenPrice()+(StopLoss*vPoint))
                        {
                         if(Ask<=OrderOpenPrice()-(BreakEvenStart*vPoint))
                          {
                           if(OrderOpenPrice()-(BreakEvenStart*vPoint)<=OrderOpenPrice()-Spread-(BreakEven*vPoint))
                            {
                              New_SL=OrderOpenPrice()-(BreakEven*vPoint);
                              
                               OrderModify(OrderTicket(),OrderOpenPrice(),New_SL,OrderTakeProfit(),0,Red);
                               
                                Alert("MoveTheSL :Attempting to move SL of ",symbol," to ",New_SL);
                                Print("MoveTheSL :Attempting to move SL of ",symbol," to ",New_SL);
                            }
                           }
                          } //End if(OrderStopLoss()==OrderOpenPrice()-(StopLoss*vPoint));
                          else
                          {
                           if(Ask-(TrailingStart*vPoint)<=OrderStopLoss())
                            {
                              New_SL=OrderStopLoss()+(TrailingStep*vPoint);
                              
                               OrderModify(OrderTicket(),OrderOpenPrice(),New_SL,OrderTakeProfit(),0,Red);
                               
                                Alert("MoveTheSL :Attempting to move SL of ",symbol," to ",New_SL);
                                Print("MoveTheSL :Attempting to move SL of ",symbol," to ",New_SL);
                            }
                           } //End else 
                          }// End if(OrderType==OP_SELL)
                         }
                        }
                       }
                      }//End for(int i=OrdersTotal()-1; i>=0,i++)
                     } 
////////////////////////////////////////////////////////////////////////////
void History_Calling(string symbol, int magic)
{ 
 int i,hstTotal=OrdersHistoryTotal();
  for(i=0;i<hstTotal;i++)
    {
     if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))continue;
       {
        if(OrderSymbol()==Symbol())
         {
          if(OrderMagicNumber()==magic)
           {
            if(OrderType()==OP_BUY)
             {
              if(OrderTicket()==BuyOrder_3)
               {
                Print("Ticket no of Last Bought Order:",BuyOrder_3);
               }
              }
             else
              {
               if(OrderType()==OP_SELL)
                { 
                 if(OrderTicket()==SellOrder_3)
                  {
                   Print("Ticket no of Last Sold Order:",SellOrder_3);
                  }
                 }
                }//End else   
             }
            }
           }
          } //End for(i=0; i<hsTotal;i++)
         } 

///////////////////////////////////////////////////////////////////////////
